<?PHP 
/*
v2.1	03.01.2010 dodao include_path, auto_prepend_file, auto_append_file
v2.0	31.12.2009 naterao da radi kao klasa
v1.2	27.11.2009
v1.1	18.11.2009
v1.0	08.11.2009
*/
class phpini{

//1 developer,programer,debug;  2 hosting,production
private $phpself; // file name
private $server;
private $title=array();
private $phpini_a=array();
private $h='';

public function __construct(){
$this->phpself = basename(__FILE__);
$this->title[1]=' Developer, Programmer, Debug ';
$this->title[2]=' Hosting, Production, WWW ';


$this->phpini_a=array(
//b-bool, m-mem, s-string, a-addition(bitmask)
//$server environment:'1'-develop, '2'-host
//'r'-return value, 'd'-description 'u'-url
'allow_url_fopen'=>array('r'=>'b','1'=>FALSE,'2'=>FALSE,'d'=>'to allow the treatment of URLs (http:// ftp://) as files','u'=>'http://php.net/allow-url-fopen'),
'allow_url_include'=>array('r'=>'b','1'=>FALSE,'2'=>FALSE,'d'=>'to allow include/require to open URLs (http:// ftp://) as files','u'=>'http://php.net/allow-url-include'),
'display_errors'=>array('r'=>'b','1'=>TRUE,'2'=>FALSE,'d'=>'Off = Do not display any errors<br />stderr = Display errors to STDERR (affects only CGI/CLI binaries!)<br />On or stdout = Display errors to STDOUT','u'=>'http://php.net/display-errors'),
'error_reporting'=>array('r'=>'a','1'=>(E_ALL|E_STRICT),'2'=>(E_ALL& ~E_DEPRECATED),'d'=>"Default Value: E_ALL & ~E_NOTICE = ".((int)E_ALL&~E_NOTICE)."<br />Development Value: E_ALL | E_STRICT = ".((int)E_ALL | E_STRICT).
"<br />Production Value: E_ALL & ~E_DEPRECATED = ".((int)E_ALL & ~E_DEPRECATED),'u'=>'http://php.net/error-reporting'),
'expose_php'=>array('r'=>'b','1'=>FALSE,'2'=>FALSE,'d'=>'whether PHP may expose the fact that it is installed on the server; (e.g. by adding its signature to the Web server header).  ','u'=>'http://php.net/expose-php'),
'file_uploads'=>array('r'=>'b','1'=>TRUE,'2'=>FALSE,'d'=>'to allow HTTP file uploads','u'=>'http://php.net/file-uploads'),
'magic_quotes_gpc'=>array('r'=>'b','1'=>FALSE,'2'=>FALSE,'d'=>'PHP will attempt to escape any character sequences in GET, POST, COOKIE and ENV data which might corrupt db','u'=>'http://php.net/magic-quotes-gpc'),
'memory_limit'=>array('r'=>'m','1'=>'8M','2'=>'8m','d'=>'Default: 16M, max: 128M, NO mem limit: -1<br />Calculate mem usage with: memory_get_peak_usage()','u'=>'http://php.net/memory-limit'),
'open_basedir'=>array('r'=>'s','1'=>FALSE,'2'=>TRUE,'d'=>'if set, limits all file operations to the defined directory and below.  Win ="d:\php\;e:\www\" otherOS="/www/:/www/"','u'=>'http://php.net/open-basedir'),
'post_max_size'=>array('r'=>'m','1'=>'1m','2'=>'256k','d'=>'Maximum size of POST data that PHP will accept','u'=>'http://php.net/post-max-size'),
'register_globals'=>array('r'=>'b','1'=>FALSE,'2'=>FALSE,'d'=>'register the EGPCS variables as global variables. Mych safer is to access all of the GPC variables through the $HTTP_*_VARS[]','u'=>'http://php.net/register-globals'),
'upload_max_filesize'=>array('r'=>'m','1'=>'256k','2'=>'256k','d'=>'Maximum allowed size for uploaded files','u'=>'http://php.net/upload-max-filesize'),
'upload_tmp_dir'=>array('r'=>'s','1'=>TRUE,'2'=>TRUE,'d'=>'Temporary directory for HTTP uploaded files (will use system default if not specified).','u'=>'http://php.net/upload-tmp-dir'),
'use_trans_sid'=>array('r'=>'b','1'=>FALSE,'2'=>FALSE,'d'=>'Use of trans sid may risk your users security.','u'=>'http://php.net/session.use-trans-sid'),
'include_path'=>array('r'=>'s','1'=>TRUE,'2'=>TRUE,'d'=>'list of directories separated with a colon in Unix or semicolon in Windows, where the require(), include(), fopen(), file(), readfile() and file_get_contents() look for files.
<br />modify or set include path at runtime using set_include_path().<br /> . means the current directory. better use include "./file"','u'=>'http://php.net/include_path',),
'auto_prepend_file'=>array('r'=>'s','1'=>FALSE,'2'=>FALSE,'d'=>'file that is automatically parsed before the main file. require(), include_path is used.<br />none disables auto-prepending.','u'=>'http://php.net/auto_prepend_file'),
'auto_append_file'=>array('r'=>'s','1'=>FALSE,'2'=>FALSE,'d'=>'file that is automatically parsed after the main file. require() ,include_path.<br />none disables auto-appending. exit() also terminates auto-append','u'=>'http://php.net/auto_append_file'),

//'phpini_property'=>array('r'=>'return','1'=>'FALSE','2'=>'FALSE','d'=>'some data','u'=>'http://php.net/include_path',),
);



// post aware
if(isset($_POST['server'])){$this->server=$_POST['server'];}else{$this->server=2;} // default is production

//initialise $h
$this->h='<html><head><title>PHP.ini security settings! _ _ _ _ _ _ _ _ _ _ Server = '.$this->server.' _ _ _ _ _ _ _ _ _ _ '.$this->title[$this->server].'</title>';
$this->h.='<style type="text/css"><!--
body{font-family: Helvetica, Arial, sans-serif;color: #000000;margin:2em 0em 0em 0em;padding:0px;}
#n{width:100%;margin:0px;padding:0px;background-color:FFFFFF;position:fixed;top:0em;left:0em;}
div form{margin:0px;padding:0px;float:left;}div span{margin:1em;}div strong{margin:2em;}
table{margin:0px;padding:0px;}tr span{float:right;}/**/td{padding:0px 4px;border: 0px solid black;/**/}a{float: right;}
#d{background-color:F1F1F1;font-family: Verdana;font-size: 0.75em;}#r{background-color:FF0000;font-size: 1.2em;}#g{background-color:00FF00;font-size: 1.1em;}#w{background-color:fuchsia;font-size: 1.2em;}
--></style></head><body>';
$this->h.='<div id="n">'.$this->button(1,'Developing ','Debug').$this->button(2,'Hosting','WWW').'<span>server = '.$this->server.'</span><strong>'.$this->title[$this->server].'</strong></div>';
$this->h.='<div>Server: '.$_SERVER['SERVER_NAME'].' Addr: '.$_SERVER['SERVER_ADDR'].' port: '.$_SERVER['SERVER_PORT'].'</div>';
$this->h.='<div>Referer: '.$_SERVER['HTTP_REFERER'].' Remore addr: '.$_SERVER['REMOTE_ADDR'].' port: '.$_SERVER['REMOTE_PORT'].
' uri: '.$_SERVER['REQUEST_URI'].'</div>';


$this->h.=$this->display_phpini();
$this->h.=$this->display_mem();
$this->h.='</body></html>';

echo $this->h;

} // end construct




//$_SERVER['PHP_SELF'] // url
//$_SERVER['SCRIPT_FILENAME'] // document fname

private function display_phpini(){

//$h.='server = '.$server;
$h='<table>';// border="0" cellpadding="0" cellspacing="0">';
while(list($a,$b)=each($this->phpini_a)) // $a ime, $b array
{
	$i=ini_get($a);
	switch($b['r']){
	case 'b': case 'B':	//bool
		if($i==TRUE){$set='On';}else{$set='Off';}
		if($i==$b[$this->server]){$css_id='g';}else{$css_id='r';}
		$h.='<tr><td id="'.$css_id.'">'.$a.' = <span>'.$set.'</span></td><td id="d">'.$b['d'].'<a href="'.$b['u'].'"> more </a>'.'</td></tr>';
	break;
	
	case 'm': case 'M':	//memory
		if($this->returnBytes($i)<=$this->returnBytes($b[$this->server])){$css_id='g';}else{$css_id='r';}
		$h.='<tr><td id="'.$css_id.'">'.$a.' = <span>'.$i.'</span></td><td id="d">'.$b['d'].'<a href="'.$b['u'].'"> more </a>'.'</td></tr>';
	break;
	
	case 's': case 'S':	//string
		if($i==$b[$this->server]){$css_id='g';}else{$css_id='r';}
		$h.='<tr><td id="'.$css_id.'">'.$a.' = <span>'.$i.'</span></td><td id="d">'.$b['d'].'<a href="'.$b['u'].'"> more </a>'.'</td></tr>';
	break;
	
	case 'a': case 'A':	//addition(bitmask)
		if($i==$b[$this->server]){$css_id='g';}else{$css_id='r';}
		$h.='<tr><td id="'.$css_id.'">'.$a.' = <span>'.$i.'</span></td><td id="d">'.$b['d'].'<a href="'.$b['u'].'"> more </a>'.'</td></tr>';
	break;
	
	default:	//warning if bad formated $phpini_a array
		$h.='<tr><td id="w">'.$a.' =<span>'.$i.'</span></td><td id="w">'.$b['d'].'Not declared properly!!!<a href="'.$b['u'].'"> more </a>'.'</td></tr>';
	break;
	} // end switch($b['r'])
} // end while

$h.='</table>server = '.$this->server.'<br />';
return $h;
} // end f get_phpini()

private function display_mem(){
$h='Memory peek: '.round(memory_get_peak_usage()/1024).'kb<br />';
$h.='Memory alocated: '.round(memory_get_peak_usage(true)/1024).'kb<br />';
return $h;
}


//echo $h;

private function returnBytes($val){$val = trim($val);$last = $val[strlen($val)-1];switch($last){case 'g': case 'G': $val *= 1024;case 'm': case 'M': $val *= 1024;case 'k': case 'K': $val *= 1024;}return $val;}
private function button($server,$btname,$bttitle=''){$s='<form action="'.$this->phpself.'" method="post"><input type="hidden" name="server" value="'.$server.'" /><input type="submit" name="submit" value="'.$btname.'" title="'.$bttitle.'" /></form>';return $s;}
} // end class phpini


$p=new phpini();





?>